import { Enums } from '../extensibility';
export declare module Control {
    interface IControlConfig {
        id?: string;
        hostId?: string;
        viewId?: string;
        init?: string;
        scope?: string;
        enableSettings?: boolean;
        settingsKey?: string;
        settingsObsoleteKey?: string;
        settings?: any;
    }
    interface IControlScope {
        containerId?: string;
        config?: Control.IControlConfig;
        settingsTemplateId?: string;
        settingsController?: string;
        pageInEditMode?: boolean;
        canEditSettings?: () => boolean;
        onSettingsChangedHandler?: () => void;
        settingComponent?: any;
        settingModule?: any;
    }
    interface IControlWithViewedHistoryScope extends Control.IControlScope {
        hasNewData: boolean;
        controlIsVisible: boolean;
        getItemIds: () => Array<string>;
    }
    interface IControlViewPortSettings {
        type?: Enums.ControlViewPortType;
        viewPort?: number;
    }
}
